searchNodes=[{"type":"module","title":"OpenTelemetry","doc":"An OpenTelemetry Trace consists of 1 or more Spans that either have a parent/child relationship or are linked together through a Link. Each Span has a TraceId ( trace_id/0 ), SpanId ( span_id/0 ), and a start and end time in nanoseconds. This module provides declaration of the types used throughout the library, as well as functions for building the additional pieces of a span that are optional. Each item can be attached to individual Span using the functions in OpenTelemetry.Span module. Example require OpenTelemetry.Tracer , as : Tracer Tracer . with_span &quot;some-span&quot; do event = OpenTelemetry . event ( &quot;ecto.query&quot; , query : query , total_time : total_time ) Tracer . add_events ( [ event ] ) end","ref":"OpenTelemetry.html"},{"type":"function","title":"OpenTelemetry.convert_timestamp/2","doc":"Convert a native monotonic timestamp to POSIX time of any :erlang.time_unit/0 . Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01.","ref":"OpenTelemetry.html#convert_timestamp/2"},{"type":"function","title":"OpenTelemetry.event/2","doc":"Creates a event/0 .","ref":"OpenTelemetry.html#event/2"},{"type":"function","title":"OpenTelemetry.event/3","doc":"Creates a event/0 .","ref":"OpenTelemetry.html#event/3"},{"type":"function","title":"OpenTelemetry.events/1","doc":"Creates a list of event/0 items.","ref":"OpenTelemetry.html#events/1"},{"type":"function","title":"OpenTelemetry.get_tracer/1","doc":"See :opentelemetry.get_tracer/1 .","ref":"OpenTelemetry.html#get_tracer/1"},{"type":"function","title":"OpenTelemetry.get_tracer/3","doc":"See :opentelemetry.get_tracer/3 .","ref":"OpenTelemetry.html#get_tracer/3"},{"type":"function","title":"OpenTelemetry.link/1","doc":"Creates a link/0 from a span_ctx/0 .","ref":"OpenTelemetry.html#link/1"},{"type":"function","title":"OpenTelemetry.link/2","doc":"Creates a link/0 from a span_ctx/0 and list of attributes_map/0 .","ref":"OpenTelemetry.html#link/2"},{"type":"function","title":"OpenTelemetry.link/4","doc":"Creates a link/0 .","ref":"OpenTelemetry.html#link/4"},{"type":"function","title":"OpenTelemetry.links/1","doc":"Creates a list of link/0 from a list of 4-tuples.","ref":"OpenTelemetry.html#links/1"},{"type":"function","title":"OpenTelemetry.set_default_tracer/1","doc":"See :opentelemetry.set_default_tracer/1 .","ref":"OpenTelemetry.html#set_default_tracer/1"},{"type":"function","title":"OpenTelemetry.status/1","doc":"Creates a Status with an empty description.","ref":"OpenTelemetry.html#status/1"},{"type":"function","title":"OpenTelemetry.status/2","doc":"Creates a Status.","ref":"OpenTelemetry.html#status/2"},{"type":"function","title":"OpenTelemetry.timestamp/0","doc":"A monotonically increasing time provided by the Erlang runtime system in the native time unit. This value is the most accurate and precise timestamp available from the Erlang runtime and should be used for finding durations or any timestamp that can be converted to a system time before being sent to another system. Use convert_timestamp/2 or timestamp_to_nano/1 to convert a native monotonic time to a system time of either nanoseconds or another unit. Using these functions allows timestamps to be accurate, used for duration and be exportable as POSIX time when needed.","ref":"OpenTelemetry.html#timestamp/0"},{"type":"function","title":"OpenTelemetry.timestamp_to_nano/1","doc":"Convert a native monotonic timestamp to nanosecond POSIX time. Meaning the time since Epoch. Epoch is defined to be 00:00:00 UTC, 1970-01-01.","ref":"OpenTelemetry.html#timestamp_to_nano/1"},{"type":"type","title":"OpenTelemetry.attribute_key/0","doc":"","ref":"OpenTelemetry.html#t:attribute_key/0"},{"type":"type","title":"OpenTelemetry.attribute_value/0","doc":"","ref":"OpenTelemetry.html#t:attribute_value/0"},{"type":"type","title":"OpenTelemetry.attributes_map/0","doc":"Attributes are a collection of key/value pairs. The value can be a string, an integer, a double or the boolean values true or false . Note, global attributes like server name can be set using the resource API. Examples of attributes: [ { &quot;/http/user_agent&quot; &quot;Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36&quot; } { &quot;/http/server_latency&quot; , 300 } { &quot;abc.com/myattribute&quot; , True } { &quot;abc.com/score&quot; , 10.239 } ]","ref":"OpenTelemetry.html#t:attributes_map/0"},{"type":"type","title":"OpenTelemetry.event/0","doc":"An Event is a time-stamped annotation of the span, consisting of user-supplied text description and key-value pairs.","ref":"OpenTelemetry.html#t:event/0"},{"type":"type","title":"OpenTelemetry.event_name/0","doc":"","ref":"OpenTelemetry.html#t:event_name/0"},{"type":"type","title":"OpenTelemetry.link/0","doc":"A Link is a pointer from the current span to another span in the same trace or in a different trace. For example, this can be used in batching operations, where a single batch handler processes multiple requests from different traces or when the handler receives a request from a different project.","ref":"OpenTelemetry.html#t:link/0"},{"type":"type","title":"OpenTelemetry.span/0","doc":"Span represents a single operation within a trace. Spans can be nested to form a trace tree. Spans may also be linked to other spans from the same or different trace and form graphs. Often, a trace contains a root span that describes the end-to-end latency, and one or more subspans for its sub-operations. A trace can also contain multiple root spans, or none at all. Spans do not need to be contiguous - there may be gaps or overlaps between spans in a trace.","ref":"OpenTelemetry.html#t:span/0"},{"type":"type","title":"OpenTelemetry.span_ctx/0","doc":"A SpanContext represents the portion of a Span needed to do operations on a Span. Within a process it acts as a key for looking up and modifying the actual Span. It is also what is serialized and propagated across process boundaries.","ref":"OpenTelemetry.html#t:span_ctx/0"},{"type":"type","title":"OpenTelemetry.span_id/0","doc":"SpanId is a unique identifier for a span within a trace, assigned when the span is created. The ID is an 8-byte array. An ID with all zeroes is considered invalid.","ref":"OpenTelemetry.html#t:span_id/0"},{"type":"type","title":"OpenTelemetry.span_kind/0","doc":"","ref":"OpenTelemetry.html#t:span_kind/0"},{"type":"type","title":"OpenTelemetry.span_name/0","doc":"","ref":"OpenTelemetry.html#t:span_name/0"},{"type":"type","title":"OpenTelemetry.status/0","doc":"An optional final status for this span. Semantically when Status wasn't set it means span ended without errors and assume unset . Application developers may set the status as ok when the operation has been validated to have completed successfully.","ref":"OpenTelemetry.html#t:status/0"},{"type":"type","title":"OpenTelemetry.status_code/0","doc":"","ref":"OpenTelemetry.html#t:status_code/0"},{"type":"type","title":"OpenTelemetry.trace_id/0","doc":"TraceId is a unique identifier for a trace. All spans from the same trace share the same trace_id . The ID is a 16-byte array. An ID with all zeroes is considered invalid.","ref":"OpenTelemetry.html#t:trace_id/0"},{"type":"type","title":"OpenTelemetry.tracestate/0","doc":"Tracestate represents tracing-system specific context in a list of key-value pairs. Tracestate allows different vendors propagate additional information and inter-operate with their legacy Id formats. It is a tracestate in the w3c-trace-context format . See also https://github.com/w3c/distributed-tracing for more details about this field.","ref":"OpenTelemetry.html#t:tracestate/0"},{"type":"module","title":"OpenTelemetry.Baggage","doc":"Baggage is used to annotate telemetry, adding context and information to metrics, traces, and logs. It is represented by a set of name/value pairs describing user-defined properties.","ref":"OpenTelemetry.Baggage.html"},{"type":"function","title":"OpenTelemetry.Baggage.clear/0","doc":"See :otel_baggage.clear/0 .","ref":"OpenTelemetry.Baggage.html#clear/0"},{"type":"function","title":"OpenTelemetry.Baggage.clear/1","doc":"See :otel_baggage.clear/1 .","ref":"OpenTelemetry.Baggage.html#clear/1"},{"type":"function","title":"OpenTelemetry.Baggage.get_all/0","doc":"See :otel_baggage.get_all/0 .","ref":"OpenTelemetry.Baggage.html#get_all/0"},{"type":"function","title":"OpenTelemetry.Baggage.get_all/1","doc":"See :otel_baggage.get_all/1 .","ref":"OpenTelemetry.Baggage.html#get_all/1"},{"type":"function","title":"OpenTelemetry.Baggage.set/1","doc":"See :otel_baggage.set/1 .","ref":"OpenTelemetry.Baggage.html#set/1"},{"type":"function","title":"OpenTelemetry.Baggage.set/2","doc":"See :otel_baggage.set/2 .","ref":"OpenTelemetry.Baggage.html#set/2"},{"type":"function","title":"OpenTelemetry.Baggage.set/3","doc":"See :otel_baggage.set/3 .","ref":"OpenTelemetry.Baggage.html#set/3"},{"type":"function","title":"OpenTelemetry.Baggage.set/4","doc":"See :otel_baggage.set/4 .","ref":"OpenTelemetry.Baggage.html#set/4"},{"type":"module","title":"OpenTelemetry.Ctx","doc":"Ctx is responsible for propagating values within a process that are associated with a particular Trace or set of Baggage. OpenTelemetry.Tracer and OpenTelemetry.Baggage handle updating the Context.","ref":"OpenTelemetry.Ctx.html"},{"type":"function","title":"OpenTelemetry.Ctx.attach/1","doc":"See :otel_ctx.attach/1 .","ref":"OpenTelemetry.Ctx.html#attach/1"},{"type":"function","title":"OpenTelemetry.Ctx.clear/0","doc":"See :otel_ctx.clear/0 .","ref":"OpenTelemetry.Ctx.html#clear/0"},{"type":"function","title":"OpenTelemetry.Ctx.detach/1","doc":"See :otel_ctx.detach/1 .","ref":"OpenTelemetry.Ctx.html#detach/1"},{"type":"function","title":"OpenTelemetry.Ctx.get_current/0","doc":"See :otel_ctx.get_current/0 .","ref":"OpenTelemetry.Ctx.html#get_current/0"},{"type":"function","title":"OpenTelemetry.Ctx.get_value/2","doc":"See :otel_ctx.get_value/2 .","ref":"OpenTelemetry.Ctx.html#get_value/2"},{"type":"function","title":"OpenTelemetry.Ctx.get_value/3","doc":"See :otel_ctx.get_value/3 .","ref":"OpenTelemetry.Ctx.html#get_value/3"},{"type":"function","title":"OpenTelemetry.Ctx.new/0","doc":"See :otel_ctx.new/0 .","ref":"OpenTelemetry.Ctx.html#new/0"},{"type":"function","title":"OpenTelemetry.Ctx.remove/1","doc":"See :otel_ctx.remove/1 .","ref":"OpenTelemetry.Ctx.html#remove/1"},{"type":"function","title":"OpenTelemetry.Ctx.set_value/2","doc":"See :otel_ctx.set_value/2 .","ref":"OpenTelemetry.Ctx.html#set_value/2"},{"type":"function","title":"OpenTelemetry.Ctx.set_value/3","doc":"See :otel_ctx.set_value/3 .","ref":"OpenTelemetry.Ctx.html#set_value/3"},{"type":"type","title":"OpenTelemetry.Ctx.t/0","doc":"","ref":"OpenTelemetry.Ctx.html#t:t/0"},{"type":"module","title":"OpenTelemetry.Span","doc":"This module contains macros for Span operations that update the active current Span in the current process. An example of creating an Event and adding it to the current Span: require OpenTelemetry.Tracer , as : Tracer require OpenTelemetry.Span , as : Span span_ctx = Tracer . start_span ( &quot;some-span&quot; ) ... Span . add_event ( span_ctx , &quot;ecto.query&quot; , query : query , total_time : total_time ) ... Span . end_span ( span_ctx ) A Span represents a single operation within a trace. Spans can be nested to form a trace tree. Each trace contains a root span, which typically describes the end-to-end latency and, optionally, one or more sub-spans for its sub-operations. Spans encapsulate: The span name An immutable SpanContext ( OpenTelemetry.span_ctx/0 ) that uniquely identifies the Span A parent Span in the form of a Span ( OpenTelemetry.span/0 ), SpanContext ( OpenTelemetry.span_ctx/0 ), or undefined A start timestamp An end timestamp An ordered mapping of Attributes ( OpenTelemetry.attributes_map/0 ) A list of Links to other Spans ( OpenTelemetry.link/0 ) A list of timestamped Events ( OpenTelemetry.event/0 ) A Status ( OpenTelemetry.status/0 )","ref":"OpenTelemetry.Span.html"},{"type":"function","title":"OpenTelemetry.Span.add_event/3","doc":"Add an event to the currently active Span.","ref":"OpenTelemetry.Span.html#add_event/3"},{"type":"function","title":"OpenTelemetry.Span.add_events/2","doc":"Add a list of events to the currently active Span.","ref":"OpenTelemetry.Span.html#add_events/2"},{"type":"function","title":"OpenTelemetry.Span.end_span/1","doc":"End the Span. Sets the end timestamp for the currently active Span. This has no effect on any child Spans that may exist of this Span. The Span Context is returned with is_recording set to false .","ref":"OpenTelemetry.Span.html#end_span/1"},{"type":"function","title":"OpenTelemetry.Span.end_span/2","doc":"End the Span. Sets the end timestamp for the currently active Span using the passed in timestamp if valid, current timestamp otherwise. This has no effect on any child Spans that may exist of this Span. The Span Context is returned with is_recording set to false .","ref":"OpenTelemetry.Span.html#end_span/2"},{"type":"function","title":"OpenTelemetry.Span.hex_span_id/1","doc":"Get the lowercase hex encoded span ID.","ref":"OpenTelemetry.Span.html#hex_span_id/1"},{"type":"function","title":"OpenTelemetry.Span.hex_trace_id/1","doc":"Get the lowercase hex encoded trace ID.","ref":"OpenTelemetry.Span.html#hex_trace_id/1"},{"type":"function","title":"OpenTelemetry.Span.is_recording/1","doc":"","ref":"OpenTelemetry.Span.html#is_recording/1"},{"type":"function","title":"OpenTelemetry.Span.is_valid/1","doc":"","ref":"OpenTelemetry.Span.html#is_valid/1"},{"type":"function","title":"OpenTelemetry.Span.record_exception/4","doc":"Record an exception as an event, following the semantics convetions for exceptions. If trace is not provided, the stacktrace is retrieved from Process.info/2","ref":"OpenTelemetry.Span.html#record_exception/4"},{"type":"function","title":"OpenTelemetry.Span.set_attribute/3","doc":"Set an attribute with key and value on the currently active Span.","ref":"OpenTelemetry.Span.html#set_attribute/3"},{"type":"function","title":"OpenTelemetry.Span.set_attributes/2","doc":"Add a list of attributes to the currently active Span.","ref":"OpenTelemetry.Span.html#set_attributes/2"},{"type":"function","title":"OpenTelemetry.Span.set_status/2","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is :unset .","ref":"OpenTelemetry.Span.html#set_status/2"},{"type":"function","title":"OpenTelemetry.Span.span_id/1","doc":"Get the SpanId of a Span.","ref":"OpenTelemetry.Span.html#span_id/1"},{"type":"function","title":"OpenTelemetry.Span.trace_id/1","doc":"Get the TraceId of a Span.","ref":"OpenTelemetry.Span.html#trace_id/1"},{"type":"function","title":"OpenTelemetry.Span.tracestate/1","doc":"Get the Tracestate of a Span.","ref":"OpenTelemetry.Span.html#tracestate/1"},{"type":"function","title":"OpenTelemetry.Span.update_name/2","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation.","ref":"OpenTelemetry.Span.html#update_name/2"},{"type":"type","title":"OpenTelemetry.Span.start_opts/0","doc":"","ref":"OpenTelemetry.Span.html#t:start_opts/0"},{"type":"module","title":"OpenTelemetry.Tracer","doc":"This module contains macros for Tracer operations around the lifecycle of the Spans within a Trace. The Tracer is able to start a new Span as a child of the active Span of the current process, set a different Span to be the current Span by passing the Span's context, end a Span or run a code block within the context of a newly started span that is ended when the code block completes. The macros start_span and with_span use the Tracer associated with the Application the module is included in. These Tracers are created at boot time for each loaded Application. require OpenTelemetry.Tracer , as : Tracer Tracer . with_span &quot;span-1&quot; do ... do something ... end","ref":"OpenTelemetry.Tracer.html"},{"type":"function","title":"OpenTelemetry.Tracer.add_event/2","doc":"Add an event to the currently active Span.","ref":"OpenTelemetry.Tracer.html#add_event/2"},{"type":"function","title":"OpenTelemetry.Tracer.add_events/1","doc":"Add a list of events to the currently active Span.","ref":"OpenTelemetry.Tracer.html#add_events/1"},{"type":"function","title":"OpenTelemetry.Tracer.current_span_ctx/0","doc":"Returns the currently active OpenTelemetry.span_ctx/0 .","ref":"OpenTelemetry.Tracer.html#current_span_ctx/0"},{"type":"function","title":"OpenTelemetry.Tracer.current_span_ctx/1","doc":"Returns the OpenTelemetry.span_ctx/0 active in Context ctx .","ref":"OpenTelemetry.Tracer.html#current_span_ctx/1"},{"type":"function","title":"OpenTelemetry.Tracer.end_span/1","doc":"End the currently active Span and sets its end timestamp. This has no effect on any child Spans that may exist of this Span. To end a specific span, see OpenTelemetry.Span.end_span/1 . The Span in the current Context has its is_recording set to false .","ref":"OpenTelemetry.Tracer.html#end_span/1"},{"type":"function","title":"OpenTelemetry.Tracer.record_exception/3","doc":"Record an exception as an event, following the semantics convetions for exceptions. If trace is not provided, the stacktrace is retrieved from Process.info/2","ref":"OpenTelemetry.Tracer.html#record_exception/3"},{"type":"function","title":"OpenTelemetry.Tracer.set_attribute/2","doc":"Set an attribute with key and value on the currently active Span.","ref":"OpenTelemetry.Tracer.html#set_attribute/2"},{"type":"function","title":"OpenTelemetry.Tracer.set_attributes/1","doc":"Add a list of attributes to the currently active Span.","ref":"OpenTelemetry.Tracer.html#set_attributes/1"},{"type":"function","title":"OpenTelemetry.Tracer.set_current_span/1","doc":"Takes a OpenTelemetry.span_ctx/0 and the Tracer sets it to the currently active Span.","ref":"OpenTelemetry.Tracer.html#set_current_span/1"},{"type":"function","title":"OpenTelemetry.Tracer.set_current_span/2","doc":"Takes a OpenTelemetry.Ctx.t/0 and the OpenTelemetry.span_ctx/0 and the Tracer sets it to the current span in the pass Context.","ref":"OpenTelemetry.Tracer.html#set_current_span/2"},{"type":"function","title":"OpenTelemetry.Tracer.set_status/1","doc":"Sets the Status of the currently active Span. If used, this will override the default Span Status, which is :unset .","ref":"OpenTelemetry.Tracer.html#set_status/1"},{"type":"function","title":"OpenTelemetry.Tracer.set_status/2","doc":"Creates and sets the Status of the currently active Span. If used, this will override the default Span Status, which is :unset .","ref":"OpenTelemetry.Tracer.html#set_status/2"},{"type":"macro","title":"OpenTelemetry.Tracer.start_span/2","doc":"Starts a new span and does not make it the current active span of the current process. The current active Span is used as the parent of the created Span.","ref":"OpenTelemetry.Tracer.html#start_span/2"},{"type":"macro","title":"OpenTelemetry.Tracer.start_span/3","doc":"Starts a new span and does not make it the current active span of the current process. The current active Span is used as the parent of the created Span.","ref":"OpenTelemetry.Tracer.html#start_span/3"},{"type":"function","title":"OpenTelemetry.Tracer.update_name/1","doc":"Updates the Span name. It is highly discouraged to update the name of a Span after its creation. Span name is often used to group, filter and identify the logical groups of spans. And often, filtering logic will be implemented before the Span creation for performance reasons. Thus the name update may interfere with this logic. The function name is called UpdateName to differentiate this function from the regular property setter. It emphasizes that this operation signifies a major change for a Span and may lead to re-calculation of sampling or filtering decisions made previously depending on the implementation.","ref":"OpenTelemetry.Tracer.html#update_name/1"},{"type":"macro","title":"OpenTelemetry.Tracer.with_span/3","doc":"Creates a new span which is set to the currently active Span in the Context of the block. The Span is ended automatically when the block completes and the Context is what it was before the block. See start_span/2 and end_span/0 .","ref":"OpenTelemetry.Tracer.html#with_span/3"},{"type":"macro","title":"OpenTelemetry.Tracer.with_span/4","doc":"Creates a new span which is set to the currently active Span in the Context of the block. The Span is ended automatically when the block completes and the Context is what it was before the block. See start_span/2 and end_span/0 .","ref":"OpenTelemetry.Tracer.html#with_span/4"},{"type":"extras","title":"Erlang/Elixir OpenTelemetry API","doc":"This is the API portion of OpenTelemetry for Erlang and Elixir Applications, implementing the API portion of the specification . This is a library, it does not start any processes, and should be the only OpenTelemetry dependency of Erlang/Elixir Applications.","ref":"readme.html"},{"type":"extras","title":"Erlang/Elixir OpenTelemetry API - Use","doc":"There are both Erlang and Elixir macros that make use of the current module's name to lookup a Named Tracer -- a Named Tracer is created for each Application loaded in the system at start time -- for you and can be used for Trace and Span operations: - include_lib ( &quot;opentelemetry_api/include/otel_tracer.hrl&quot; ) . some_fun ( ) -&gt; ? with_span ( &lt;&lt; &quot;some_fun/0&quot; &gt;&gt; , \#{ } , fun ( _ SpanCtx ) -&gt; . . . ? set_attribute ( &lt;&lt; &quot;key&quot; &gt;&gt; , &lt;&lt; &quot;value&quot; &gt;&gt; ) , . . . end ) , require OpenTelemetry.Tracer def some_fun ( ) do OpenTelemetry.Tracer . with_span &quot;some-span&quot; do ... OpenTelemetry.Tracer . set_attribute ( &quot;key&quot; , &quot;value&quot; ) ... end end Tracing API The macros and functions available for Elixir in OpenTelemetry.Tracer and the Erlang macros in otel_tracer.hrl are the best way to work with Spans. They will automatically use the Tracer named for the Application the module using the macro is in. For example, the Spans created in opentelemetry_oban use the with_span macro resulting in the Span being created with the opentelemetry_oban named Tracer and associated with the Instrumentation Library of the same name and version of the Tracer -- the version also matches the opentelemetry_oban Application version. Context Context is used to pass values associated with the current execution unit . At this time the only values kept in the Context by this OpenTelemetry library are the Span Context for the currently active Span and the Baggage When a Context variable is not an explicit argument in the API macros or functions the Context from the process dictionary is used. If no Context is found in the current process's pdict then one is created. Starting and Ending Spans A Span represents a single operation in a Trace. It has a start and end time, can have a single parent and one or more children. The easiest way to create Spans is to wrap the operation you want a Span to represent in the with_span macro. The macro handles getting a Tracer associated with the OTP Application the module is in, starting the Span, setting it as the currently active Span in the Context stored in the process dictionary and ending the Span when the Fun or body of the Elixir macro finish, even if an exception is thrown -- however, the exception is not caught, so it does not change how user code should deal with raised exceptions. After the Span is ended the Context in the process dictionary is reset to its value before the newly started Span was set as the active Span. This handling of the active Span in the process dictionary ensures proper lineage of Spans is kept when starting and ending child Spans. ? with_span ( SpanName , StartOpts , Fun ) OpenTelemetry.Tracer . with_span name , start_opts do ... end StartOpts / start_opts is a map of Span creation options : kind : SpanKind defines the relationship between the Span, its parents, and its children in a Trace. Possible values: internal , server , client , producer and consumer . Defaults to internal if not specified. attributes : See Attributes for details about Attributes. Default is an empty list of attributes. links : List of Links to causally related Spans from the same or a different Trace. start_time : The start time of the Span operation. Defaults to the current time. The option should only be set if the start of the operation described by the Span has already passed. current_span_ctx(ctx) set_current_span(span_ctx) When using start_span instead of with_span there must be a corresponding call to the end Span API to signal that the operation described by the Span has ended. end_span optionally takes a timestamp to use as the end time of the Span. ? end_span ( ) ? end_span ( Timestamp ) OpenTelemetry.Tracer . end_span ( timestamp \\\\ :undefined ) Sampling Sampling is performed at span creation time by the Sampler configured on the Tracer, see Samplers . To pass attributes for use by the sampler, use the attributes field of StartOpts / start_opts example: OpenTelemetry.Tracer . start_span ( span_name , %{ attributes : %{ my_attribute : &quot;my value&quot; } } ) Setting Attributes Setting Attributes can be done with a single key and value passed to set_attribute or through a map of Attributes all at once. Setting an attribute with a key that already exists in the Span's map of attributes will result in that key's value being overwritten. ? set_attribute ( Key , Value ) ? set_attributes ( Attributes ) OpenTelemetry.Tracer . set_attribute ( key , value ) OpenTelemetry.Tracer . set_attributes ( attributes ) Be aware that there are configurable limits on the number and size of Attributes per Span. Adding Events Adding Events can be done by passing the name of the event and the Attributes to associate with it or as a list of Events. Each Event in the list of Events is a map containing the timestamp, name, and Attributes which can be created with the function event/2 and event/3 in the opentelemetry and OpenTelemetry modules. ? add_event ( Name , Attributes ) ? add_events ( Events ) OpenTelemetry.Tracer . add_event ( event , attributes ) OpenTelemetry.Tracer . add_events ( events ) Setting the Status Set Status will override the default Span Status of Unset . A Status is a code ( ok , error or unset ) and, only if the code is error , an optional message string that describes the error. ? set_status ( Code , Message ) OpenTelemetry.Tracer . set_status ( code , message ) Update Span Name Updating the Span name can be done after starting the Span but must be done before the Span is end'ed. ? update_name ( Name ) OpenTelemetry.Tracer . update_name ( name ) Including the OpenTelemetry SDK When only the API is available at runtime a no-op Tracer is used and no Traces are exported. The OpenTelemetry SDK provides the functionality of Tracers, Span Processors and Exporters and should be included as part of a Release and not as a dependency of any individual Application. Exporters Included in the same Github repo as the API and SDK are an exporter for the OpenTelemetry Protocol (OTLP) and Zipkin : OpenTelemetry Protocol Zipkin Log Correlation When a Span is made active in a process, for example when the with_span macro is used, it is added to the logger metadata . The metadata is under the key otel_span_ctx . Example usage: { kernel , [ { logger_level , debug } , { logger , [ { handler , default , logger_std_h , \#{ formatter =&gt; { logger_formatter , \#{ template =&gt; [ time , &quot; &quot; , file , &quot;:&quot; , line , &quot; &quot; , level , &quot;: &quot; , { otel_trace_id , [ &quot;trace_id=&quot; , otel_trace_id , &quot; &quot; ] , [ ] } , { otel_span_id , [ &quot;span_id=&quot; , otel_span_id , &quot; &quot; ] , [ ] } , msg , &quot;\\n&quot; ] } } } } ] } ] } Integrations Instrumentations of many popular Erlang and Elixir projects can be found in the contrib repo and on hex.pm under the OpenTelemetry organization .","ref":"readme.html#use"},{"type":"extras","title":"Erlang/Elixir OpenTelemetry API - Contributing","doc":"Read OpenTelemetry project contributing guide for general information about the project.","ref":"readme.html#contributing"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"},{"type":"extras","title":"Versioning and Releasing","doc":"OTP Applications and the OpenTelemetry Spec itself use semver v2 . In this document, references to OTP concepts are distinguished by capitalizing the word (for example Application and Release) while the generic term (like release) is lowercase.","ref":"versioning.html"},{"type":"extras","title":"Versioning and Releasing - Module Prefix","doc":"The module prefix for all modules in any of these core Applications is otel . This means modules can move between Applications without their name changing. Because of Erlang's flat namespace, there is no code for a user to change when an API graduates from experimental to stable, if the user was using the latest version of the experimental API. This also allows flexibility for modules that might be in the SDK but are found to be better placed in the API, or vice versa. This has happened a few times in the pre-1.0 world as functionality was floating from SDK to API at times.","ref":"versioning.html#module-prefix"},{"type":"extras","title":"Versioning and Releasing - OTP Applications","doc":"Experimental API ( opentelemetry_api_experimental ) The experimental package is where any API that is not stable when 1.0 is released MUST live. At this time (prior to 1.0) that means Metrics and Logging. This package will always be 0.x because it is never stable and modules will be removed when they are moved to the stable API package. Breaking changes, as well as non-trivial additions, to the experimental API will only result in a minor version bump. API ( opentelemetry_api ) The API package must provide semver-defined backwards-compatibility once a major version (e.g. 1.0.0) is released. When a particular part of the API becomes stable, its modules are moved from opentelemetry_api_experimental to opentelemetry_api and a new minor release of both is published. At the release of version 1.0, the following signal APIs will be included in opentelemetry_api : Tracing Baggage Context Experimental SDK ( opentelemetry_sdk_experimental ) The experimental SDK contains the implementations for the APIs in the experimental API of the same minor version. For example, there may be multiple patch-level releases ( v0.3.2 , v0.3.3 ) of the experimental SDK for each minor version of the experimental API ( v0.3.0 ). Any setup for signals contained in the experimental SDK must be done on startup of the experimental SDK. For example, setting the default Meter would be done in start/2 of opentelemetry_sdk_experimental . SDK ( opentelemetry ) Functionality is implemented in this Application and the API is dynamically configured to use a particular SDK -- at this time there is only 1 SDK implementation, the default implementation. A goal is that the latest SDK can always be used with any version of the API, so that a user can always pull the latest implementation into their final Release to run with any API versions that were used in instrumented Applications within the Release. OTLP Exporter ( opentelemetry_exporter ) Exporter implementations are tied to the SDK's public API.","ref":"versioning.html#otp-applications"},{"type":"extras","title":"Versioning and Releasing - Releases","doc":"Experimental API As noted in the previous section, opentelemetry_api_experimental is versioned separately from the rest and will always remain 0.x. API Additions to the API are released with minor version bumps. Experimental SDK As noted in the previous section, opentelemetry_sdk_experimental is versioned separately from the rest, but in lockstep with opentelemetry_api_experimental , and will always remain 0.x. SDK Additions to the SDK are released with minor version bumps.","ref":"versioning.html#releases"},{"type":"extras","title":"Versioning and Releasing - Deprecation","doc":"Code is only marked as deprecated when the replacement is stable. Unlikely example: There is a Tracing v2 spec defined. The module will be named otel_trace2 and the functions in otel_trace marked as deprecated. Deprecated functions must be marked with -deprecated in the module so that xref provides a warning about usage to the user.","ref":"versioning.html#deprecation"},{"type":"extras","title":"Versioning and Releasing - Removal","doc":"A major version bump is required to remove a signal or module. In the unlikely example mentioned in the Deprecation section, this step would mean removal of the original module ( otel_trace ) and a major version bump release.","ref":"versioning.html#removal"},{"type":"extras","title":"Versioning and Releasing - Examples","doc":"Purely for illustration purposes, not intended to represent actual releases: v1.0.0 release: opentelemetry_api 1.0.0 Contains APIs for tracing, baggage, propagators opentelemetry_api_experimental 0.2.0 Contains APIs for metrics opentelemetry_sdk 1.0.0 opentelemetry_sdk_experimental 0.2.0 v1.15.0 release (with metrics) opentelemetry_api 1.15.0 Contains APIs for tracing, baggage, propagators, metrics opentelemetry_api_experimental 0.42.0 No longer contains APIs for metrics opentelemetry_sdk 1.15.0 opentelemetry_sdk_experimental 0.42.0","ref":"versioning.html#examples"}]